Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 683256 - dev-lisp/gcl-2.6.12 - Error: ERROR "The assertion tp&^tp on line 185 of sfaslelf.c in function relocate failed"
Summary: dev-lisp/gcl-2.6.12 - Error: ERROR "The assertion tp&^tp on line 185 of sfasl...
Status: UNCONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: AMD64 Linux
: Normal normal with 1 vote (vote)
Assignee: Common Lisp Bugs
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2019-04-13 18:04 UTC by LP
Modified: 2020-09-04 23:55 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,143.55 KB, text/plain)
2019-04-13 22:57 UTC, LP
Details
ebuild for gcl-2.6.13_pre90 (gcl-2.6.13_pre90.ebuild,3.81 KB, patch)
2020-04-02 19:12 UTC, Petr Zima
Details | Diff
Rebased Fedora patches for the ebuild (rebased-fedora-patches.tar.xz,170.87 KB, application/x-xz)
2020-04-02 19:16 UTC, Petr Zima
Details

Note You need to log in before you can comment on or make changes to this bug.
Description LP 2019-04-13 18:04:50 UTC
Dev-Lisp/GCL-2.6.12 fails to emerge.  An error is reported in the build log:

Finished compiling /tmp/portage-acc/tmp/portage/dev-lisp/gcl-2.6.12/work/gcl/unixport/../pcl/gcl_pcl_pkg.o.
Loading binary of GCL_PCL_PKG...
Loading /tmp/portage-acc/tmp/portage/dev-lisp/gcl-2.6.12/work/gcl/unixport/../pcl/gcl_pcl_pkg.o
Unknown reloc type 4

Error: ERROR "The assertion tp&^tp on line 185 of sfaslelf.c in function relocate failed"
Fast links are on: do (si::use-fast-links nil) for debugging
Signalled by LOAD.
ERROR "The assertion tp&^tp on line 185 of sfaslelf.c in function relocate failed"

Broken at LOAD.  Type :H for Help.
    1  Return to top level. 
>>make[1]: *** [makefile:36: gcl_pcl_boot.c] Error 255
make[1]: Leaving directory '/tmp/portage-acc/tmp/portage/dev-lisp/gcl-2.6.12/work/gcl/pcl'
make: *** [makefile:87: unixport/saved_pcl_gcl] Error 2
rm h/mcompdefs.h
ERROR: dev-lisp/gcl-2.6.12::gentoo failed (compile phase):
emake failed



Reproducible: Always

Steps to Reproduce:
1. emerge gcl




Since I need gcl for maxima, I am using the Debian binary version of gcl which has been heavily patched

https://packages.debian.org/sid/gcl

I tried to compile gcc from the GNU source but it fails in the same way.  The problem is apparently upstream.

Unfortunately, I cannot decipher the over 100 patches in the Debian release to find the patch that fixes the issue.
Comment 1 Jonas Stein gentoo-dev 2019-04-13 19:43:43 UTC
Thank you for the report. Please recompile and 
*attach* the logfiles and 
paste the emerge info as described on
https://wiki.gentoo.org/wiki/Attach_the_logs_to_the_bug_ticket
The logs must be part of the ticket, but not on external websites.
We need to have all information at hand before ticket assignment, so that the maintainer can look after it in one session with minimal number of callbacks.

btw: Does dev-lisp/gcl-2.6.10 work for you?
Please reopen this ticket (Status:unconfirmed) afterwards.
Comment 2 LP 2019-04-13 22:57:03 UTC
Created attachment 572690 [details]
build.log

build.log
Comment 3 LP 2019-04-13 22:58:31 UTC
Portage 2.3.62 (python 3.6.8-final-0, default/linux/amd64/17.0/no-multilib, gcc-8.3.0, glibc-2.29-r1, 5.0.0 x86_64)
=================================================================
System uname: Linux-5.0.0-x86_64-Intel-R-_Core-TM-_i7-4770_CPU_@_3.40GHz-with-gentoo-2.6
KiB Mem:    16341916 total,  13503860 free
KiB Swap:   33554428 total,  33554428 free
Timestamp of repository gentoo: Sat, 13 Apr 2019 16:45:01 +0000
Head commit of repository gentoo: a6bf0debc2f601edfece954d08bfd906d3525dbb
sh bash 5.0_p3-r1
ld GNU ld (Gentoo 2.32 p1) 2.32.0
app-shells/bash:      5.0_p3-r1::gentoo
dev-lang/perl:        5.26.2::gentoo
dev-lang/python:      2.7.16::gentoo, 3.6.8::gentoo
dev-util/cmake:       3.14.2::gentoo
dev-util/pkgconfig:   0.29.2::gentoo
sys-apps/baselayout:  2.6-r1::gentoo
sys-apps/openrc:      0.41.2::gentoo
sys-apps/sandbox:     2.17::gentoo
sys-devel/autoconf:   2.69-r4::gentoo
sys-devel/automake:   1.9.6-r5::gentoo, 1.11.6-r3::gentoo, 1.13.4-r2::gentoo, 1.15.1-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:   2.31.1-r4::gentoo, 2.32::gentoo
sys-devel/gcc:        8.3.0::gentoo
sys-devel/gcc-config: 2.0::gentoo
sys-devel/libtool:    2.4.6-r5::gentoo
sys-devel/make:       4.2.1-r4::gentoo
sys-libs/glibc:       2.29-r1::gentoo
Repositories:

gentoo
    location: /tmp/portage
    sync-type: rsync
    sync-uri: rsync://rsync.namerica.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-metamanifest: no
    sync-rsync-extra-opts: --exclude-from=/etc/portage/rsync_excludes

local_overlay
    location: /tmp/portage-acc/overlay
    masters: gentoo

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CC="gcc"
CFLAGS="-O2 -pipe -march=native -floop-interchange -floop-strip-mine -floop-block -mfpmath=sse -fno-stack-protector -mindirect-branch=keep -mfunction-return=keep --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -U_FORTIFY_SOURCE"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /root /usr/etc /usr/libexec/mc /usr/local/etc /usr/share/gnupg/qualified.txt /usr/share/mc"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CPPFLAGS="-U_FORTIFY_SOURCE"
CXX="g++"
CXXFLAGS="-O2 -pipe -march=native -floop-interchange -floop-strip-mine -floop-block -mfpmath=sse -fno-stack-protector -mindirect-branch=keep -mfunction-return=keep --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -U_FORTIFY_SOURCE"
DISTDIR="/tmp/portage-acc/distfiles"
EMERGE_DEFAULT_OPTS="--with-bdeps=y --quiet-build=n --changed-deps-report=n"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe -march=native -floop-interchange -floop-strip-mine -floop-block -mfpmath=sse -fno-stack-protector -mindirect-branch=keep -mfunction-return=keep --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -U_FORTIFY_SOURCE"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles force-prefix ipc-sandbox merge-sync multilib-strict network-sandbox news nodoc parallel-fetch pid-sandbox protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe -march=native -floop-interchange -floop-strip-mine -floop-block -mfpmath=sse -fno-stack-protector -mindirect-branch=keep -mfunction-return=keep --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -U_FORTIFY_SOURCE"
GENTOO_MIRRORS="ftp://ftp.ussg.iu.edu/pub/linux/gentoo ftp://mirrors.rit.edu/gentoo ftp://gentoo.cites.uiuc.edu/pub/gentoo ftp://ftp.gtlib.gatech.edu/pub/gentoo"
LANG="en_US.UTF-8"
LC_ALL="en_US.UTF-8"
LDFLAGS="-Wl,--as-needed -Wl,-O1 -Wl,--hash-style=gnu -Wl,--sort-common -O2 -pipe -march=native -floop-interchange -floop-strip-mine -floop-block -mfpmath=sse -fno-stack-protector -mindirect-branch=keep -mfunction-return=keep --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -U_FORTIFY_SOURCE"
LINGUAS="en en-US"
MAKEOPTS="-j9"
PKGDIR="/tmp/portage-acc/packages"
PORTAGE_BINHOST=""
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--exclude-from=/etc/portage/rsync_excludes"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/tmp/portage-acc/tmp"
USE="X alsa amd64 berkdb blas bzip2 cairo cli css cxx dri exif fftw fontconfig fortran gdbm gif gmp gnutls iconv idn imlib jpeg lame lcms libtirpc motif ncurses nptl opengl openmp pcre png readline seccomp smp sndfile spell svg tcpd threads tiff truetype unicode vdpau xcb zlib" ABI_X86="64" ALSA_CARDS="dummy ice1712 intel-hda" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 f16c fma3 mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="keyboard mouse" KERNEL="linux" L10N="en en-US" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6 php7-1" POSTGRES_TARGETS="postgres9_5 postgres10" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="nvidia svga vesa" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CTARGET, INSTALL_MASK, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS
Comment 4 LP 2019-04-13 23:07:42 UTC
(In reply to Jonas Stein from comment #1)
> 
> btw: Does dev-lisp/gcl-2.6.10 work for you?
> 

For me gcl-2.6.10 also fails as in Gentoo bug # 640322.

But the gcl-2.6.12 failure has been reported in a different contexts:

https://bugzilla.redhat.com/show_bug.cgi?id=1145521

https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=228055
Comment 5 LP 2019-04-14 13:46:32 UTC
I tried to compile the gcl development verion, gcl-Version_2_6_13pre84,
and was successful.  A tarball of this version is found here:

http://git.savannah.gnu.org/cgit/gcl.git

Whatever was causing the problem with 2.6.12 seesm to be fixed in this newer gcl pre-release.

Maybe the maintainer will not want to waste effort with patching 2.6.12 and just package a 2.6.13 pre-release.
Comment 6 Petr Zima 2020-04-02 19:12:43 UTC
Created attachment 629156 [details, diff]
ebuild for gcl-2.6.13_pre90

Thanks for suggesting using pre-release version 2.6.13, works for me.
Comment 7 Petr Zima 2020-04-02 19:16:19 UTC
Created attachment 629158 [details]
Rebased Fedora patches for the ebuild

Rebased and adjusted to work with 2.6.13_pre90. I am not sure that the patches are 100 % correct. Some of them are ugly, because configure contains large similar sections, using diff --patience may produce nicer ones. Anyway, works for me :)
Comment 8 segmentation fault 2020-05-11 01:21:04 UTC
Just to give you some feedback: I had this error:

ERROR "Caught fatal error [memory may be damaged]"

at the "unixport" directory, with both versions currently offered, 2.6.10 and 2.6.12. 

My memory chips are fine.

Some info:
Portage 2.3.89 (python 3.6.10-final-0, default/linux/amd64/17.0/hardened, gcc-9.2.0, glibc-2.29-r7, 4.19.81-gentoo x86_64)
=================================================================
System uname: Linux-4.19.81-gentoo-x86_64-Intel-R-_Core-TM-_i7-6700HQ_CPU_@_2.60GHz-with-gentoo-2.6
Timestamp of repository gentoo: Sun, 29 Mar 2020 00:45:01 +0000
sh bash 4.4_p23-r1
ld GNU ld (Gentoo 2.33.1 p2) 2.33.1
app-shells/bash:          4.4_p23-r1::gentoo
dev-java/java-config:     2.2.0-r4::gentoo
dev-lang/perl:            5.30.1::gentoo
dev-lang/python:          2.7.17-r1::gentoo, 3.6.10::gentoo, 3.7.6::gentoo
dev-util/cmake:           3.16.5::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/openrc:          0.42.1::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.12.6::gentoo, 1.13.4-r2::gentoo, 1.14.1::gentoo, 1.15.1-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.30-r4::gentoo, 2.32-r1::gentoo, 2.33.1-r1::gentoo
sys-devel/gcc:            7.3.0-r3::gentoo, 7.4.0-r2::gentoo, 8.3.0-r1::gentoo, 9.2.0-r2::gentoo
sys-devel/gcc-config:     2.2.1::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 5.4::gentoo (virtual/os-headers)
sys-libs/glibc:           2.29-r7::gentoo

GCC used: 9.2.0
binutils used: 2.33.1

Trying the ebuild and patches by Petr Zima worked for me. The only file you also need in your files directory, besides these patches, is 64gcl-gentoo.el. Also note this:

 * The ebuild is installing to one or more unexpected paths:
 * 
 *   /default.el
 * 
 * Please fix the ebuild to use correct FHS/Gentoo policy paths.

and indeed there was a default.el file in my root (/) dir after installation.

Please don't ask for the build.log, as it was deleted after the successful merge of gcl-2.6.13_pre90.

Thus me too supports LP's suggestion to package gcl-2.6.13_preXX and move on.
Comment 9 Ulrich Müller gentoo-dev 2020-06-21 11:34:53 UTC
(In reply to Petr Zima from comment #7)
> Created attachment 629158 [details]
> Rebased Fedora patches for the ebuild
> 
> Rebased and adjusted to work with 2.6.13_pre90. I am not sure that the
> patches are 100 % correct. Some of them are ugly, because configure contains
> large similar sections, using diff --patience may produce nicer ones.
> Anyway, works for me :)

So these patches would go on top of pre90? It is a giant patchset with some 30000 lines, so I am reluctant to include them. Have these patches been accepted by GCL upstream? (Or if they haven't, then why not?)

Other comments say that the prerelease version (would be 2.6.13_pre91 currently) just works.
Comment 10 Petr Zima 2020-06-21 19:30:02 UTC
> So these patches would go on top of pre90? It is a giant patchset with some
> 30000 lines, so I am reluctant to include them. Have these patches been
> accepted by GCL upstream? (Or if they haven't, then why not?)
> 
> Other comments say that the prerelease version (would be 2.6.13_pre91
> currently) just works.

Yes, those patches go on top of pre90 and it works here. But I have no idea if they are needed and what are they for. I have just mechanically rebased the Fedora patches which are used by the ebuild for 2.6.12 in portage. If I remember well some of it seemed quite like bikeshedding from a quick look, but I haven't examined it in detail.
Comment 11 Petr Zima 2020-06-21 19:44:38 UTC
As I wrote in the comment, the patches are ugly and large, because diff was confused by large similar sections in some files. Apllying them and re-diffing with --patience may produce something smaller and readable. But I was just happy to get it working and so far no problems. I use gcl just for maxima which I use quite often.
Comment 12 Petr Zima 2020-06-21 20:20:28 UTC
I have just recompiled gcl-2.6.13_pre90 without the patches and maxima-5.44.0 and it works fine. So regarding me, you can drop them completely.
Comment 13 Sam James gentoo-dev Security 2020-09-04 23:55:43 UTC
(In reply to Petr Zima from comment #12)
> I have just recompiled gcl-2.6.13_pre90 without the patches and
> maxima-5.44.0 and it works fine. So regarding me, you can drop them
> completely.

Thank you.